use organic::types::Document;
use serde::Deserialize;
use serde::Serialize;

use super::macros::to_wasm;
use super::standard_properties::WasmStandardProperties;
use super::to_wasm::ToWasm;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Serialize, Deserialize)]
#[serde(tag = "ast_node")]
#[serde(rename = "org-data")]
pub(crate) struct WasmDocument {
    standard_properties: WasmStandardProperties,
    children: Vec<()>,
}

to_wasm!(
    WasmDocument,
    Document<'s>,
    wasm_context,
    standard_properties,
    {
        Ok(WasmDocument {
            standard_properties,
            children: Vec::new(),
        })
    }
);
